// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: copyfrom.go

package queries

import (
	"context"
)

// iteratorForCreateRecords implements pgx.CopyFromSource.
type iteratorForCreateRecords struct {
	rows                 []*CreateRecordsParams
	skippedFirstNextCall bool
}

func (r *iteratorForCreateRecords) Next() bool {
	if len(r.rows) == 0 {
		return false
	}
	if !r.skippedFirstNextCall {
		r.skippedFirstNextCall = true
		return true
	}
	r.rows = r.rows[1:]
	return len(r.rows) > 0
}

func (r iteratorForCreateRecords) Values() ([]interface{}, error) {
	return []interface{}{
		r.rows[0].ID,
		r.rows[0].GroupID,
		r.rows[0].CorrelationID,
		r.rows[0].ActorType,
		r.rows[0].ActorUserName,
		r.rows[0].ActorUserEmail,
		r.rows[0].ActorServiceSubjectCommonName,
		r.rows[0].ActorServicePublicKeyThumbprint,
		r.rows[0].EventType,
		r.rows[0].EventContractContentHash,
		r.rows[0].EventServiceName,
		r.rows[0].EventFailedDistributionRetryContentHash,
		r.rows[0].EventFailedDistributionRetryPeerID,
		r.rows[0].EventFailedDistributionRetryAction,
		r.rows[0].EventPeerID,
		r.rows[0].SourceType,
		r.rows[0].SourceHttpIpAddress,
		r.rows[0].SourceHttpUserAgent,
		r.rows[0].StatusType,
		r.rows[0].StatusError,
		r.rows[0].Component,
		r.rows[0].CreatedAt,
	}, nil
}

func (r iteratorForCreateRecords) Err() error {
	return nil
}

// Copyright © VNG Realisatie 2023
// Licensed under the EUPL
func (q *Queries) CreateRecords(ctx context.Context, arg []*CreateRecordsParams) (int64, error) {
	return q.db.CopyFrom(ctx, []string{"auditlog", "records"}, []string{"id", "group_id", "correlation_id", "actor_type", "actor_user_name", "actor_user_email", "actor_service_subject_common_name", "actor_service_public_key_thumbprint", "event_type", "event_contract_content_hash", "event_service_name", "event_failed_distribution_retry_content_hash", "event_failed_distribution_retry_peer_id", "event_failed_distribution_retry_action", "event_peer_id", "source_type", "source_http_ip_address", "source_http_user_agent", "status_type", "status_error", "component", "created_at"}, &iteratorForCreateRecords{rows: arg})
}
